# TP Loto

Énoncé du TP : [https://tp-vhdl.gitlab-pages.imt-atlantique.fr/loto/](https://tp-vhdl.gitlab-pages.imt-atlantique.fr/loto/)

## Question Loto 1 : Quels sont les signaux à renseigner dans la liste de sensibilité (si vous utilisez un process explicite) ?
Liste de sensibilité : I_0, I_1, I_2, I_3, I_4, I_5 et I_sel.


## Question Loto 2 : Que se passe-t-il si le test est incomplet, c’est-à-dire s’il ne couvre pas toutes les combinaisons d’entrées du module ? Est-ce grave ?
Si le "when others" est supprimé, le code ne le détecte pas; mais sur la simulation, la sortie affiche une erreur car elle ne trouve pas les autres signaux : "case statement does not cover all choices; 'others' clause is needed".
De plus, sur la simulation, les valeurs de case "110" et "111" ne sont pas présents sur la simulation, mais cela n'a pas géné la simulation.
![](./Q2.png)


## Question Loto 3 : Ce test est-il concluant ? Est-il suffisant pour valider le module ? Justifiez.
Tous les cas ont été testés, la sortie affiche bien la valeur de l'entrée selon les différents case (entre "000" à "101").


## Question Loto 4 : Quel(s) signal(aux) doit on renseigner dans la liste de sensibilité de ce processus séquentiel ? Pourquoi ?
Liste de sensibilité : I_rst et I_clk. En effet, dans le compteur, on utilise l'horloge pour incrémenter le compteur, et la présence du reset réinitialise le compteur.


## Question Loto 5 : Que se passe-t-il si le test est incomplet, c’est-à-dire s’il ne couvre pas toutes les combinaisons d’entrées du module ? Est-ce grave ici ?
Le code empêche la valeur du compteur de passer à "110" et "111", donc la simulation n'est pas affectée par ces combinaisons d'entrées.


## Question Loto 6 : Ce test est-il concluant ? Est-il suffisant pour valider le module ? Justifiez.
Tous les cas sont testés, le compteur repasse bien à 0 après avoir atteint la valeur 5.
![](./Q6.png)


## Question Loto 7 : Combien de processus avez-vous décris ?
On a utilisé un processus.


## Question Loto 8 : De quel(s) type(s) sont-ils
C'est un processus synchrone.


## Question Loto 9 : Serait-il possible de décrire cette machine d'état de manière différente, en terme de nombre et de type de process ?
On peut la décrire avec 2 processus, le premier processus comprends la mise à jour de l'état, l'autre à changer les paramètres et déterminer l'état suivant.


## Question Loto 10 : Ce test est-il concluant ? Justifiez.
![](./Q10.png)


## Question Loto 11 : Le circuit inféré par l’outil est-il conforme à l’attendu ? Sinon, en quoi diffère-t-il et est-ce lié à une erreur de description VHDL ?
Le schéma n'affiche pas complètement le même que le résultat attendu, il y n'a pas la présence d'un buffer. La différence n'est pas liée à une erreur VHDL.


## Question Loto 12 : Quelles sont les ressources utilisées sur le FPGA ? En quelle quantité/proportion des ressources disponibles ? Des **LATCHES** sont-ils utilisés ? Est-ce positif ou pas, pourquoi ?
73 LUTs, 89 Flip Flops, 0 latch. S'il n'y a pas de latch, c'est un bon point car cela utilise moins de matériel.


## Question Loto 13 : Le tirage est-il aléatoire pour un humain ? pour une machine ? Justifiez.
C'est aléatoire pour un humain mais pas pour une machine car la machine se sert du cycle d'horloge pour créer un pseudo-aléatoire.
